﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Bullet : MonoBehaviour
{

    GameObject Player;
    public GameObject hit;
	public GameObject ExplosionParticle;
	public List <GameObject> EnemyList = new List <GameObject>();
	// Use this for initialization
	void Start ()
    {
        Player = GameObject.FindWithTag("Player");

        Destroy(this.gameObject, Player.GetComponent<PlayerMovement>().guns[StaticData.ChoosenGun].BulletLifeTime);
		
		if (StaticData.ChoosenGun == 1)
		{
			EnemyList.AddRange(GameObject.FindGameObjectsWithTag("Enemy"));
		}
    }
	
	// Update is called once per frame
	void Update ()
    {
        this.GetComponent<Rigidbody>().velocity = -this.transform.up * Player.GetComponent<PlayerMovement>().guns[StaticData.ChoosenGun].BulletSpeed;
    }

    void OnTriggerEnter(Collider other)
    {
        if (other.tag == "Enemy" || other.tag == "POD")
        {
            if (StaticData.ChoosenGun == 1)
			{
				Instantiate(ExplosionParticle, other.transform.position, Quaternion.identity);
				foreach (GameObject Target in EnemyList)
				{
					float dist = Vector3.Distance(transform.position, Target.transform.position);
					if (dist < 1.5)
					{
						Target.GetComponent<Enemy>().health -= Player.GetComponent<PlayerMovement>().guns[StaticData.ChoosenGun].Damage;
					}
				}
			}
			else
			{
				other.transform.GetComponent<Enemy>().health -= Player.GetComponent<PlayerMovement>().guns[StaticData.ChoosenGun].Damage;
			}
			
            Instantiate(hit, other.transform.position, Quaternion.identity);

            Destroy(this.gameObject);
        }
    }
}
