﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MainMenuScript : MonoBehaviour {

    public GameObject Camera;
    public GameObject player;
    public GameObject UICanvas;
    public GameObject PlayerHUD;
    public GameObject WaveSystem;
    public GameObject HelpScreen;
    public GameObject ControlScreen;

    // Use this for initialization
    void Start () {
        player = GameObject.FindWithTag("Player");
        PlayerHUD = GameObject.FindWithTag("PlayerHUD");

        if (GameObject.Find("Player"))
        {
            player.SetActive(false);
        }

        if (GameObject.Find("PlayerHUD"))
        {
            PlayerHUD.SetActive(false);
        }

    }
	
	// Update is called once per frame
	void Update () {
		
	}

    public void StartGame()
    {
        player.SetActive(true);
        UICanvas.SetActive(false);
        Camera.GetComponent<AudioSource>().Play();
        iTween.MoveTo(Camera, iTween.Hash("x", -0.1f, "y", 29, "z", -11.68f, "time", 2, "easeType", "easeInCubic"));
        PlayerHUD.SetActive(true);
        WaveSystem.SetActive(true);

    }

    public void ShowControlScreen()
    {
        ControlScreen.SetActive(true);
        HelpScreen.SetActive(false);
        UICanvas.SetActive(false);
    }

    public void ShowHelpScreen()
    {
        ControlScreen.SetActive(false);
        HelpScreen.SetActive(true);
        UICanvas.SetActive(false);
    }

    public void Back()
    {
        ControlScreen.SetActive(false);
        HelpScreen.SetActive(false);
        UICanvas.SetActive(true);
    }
}
