﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MoveToPlanet : MonoBehaviour {

    GameObject planet;
    public float fallspeed = 10f;

    // Use this for initialization
    void Start ()
    {
        planet = GameObject.FindWithTag("planet");
    }
	
	// Update is called once per frame
	void Update ()
    {
        UpdatePlayerTransform(transform.forward);
        this.transform.LookAt(planet.transform);
    }

    private void UpdatePlayerTransform(Vector3 movementDirection)
    {
        RaycastHit hitInfo;

        if (GetRaycastDownAtNewPosition(movementDirection, out hitInfo))
        {
            Quaternion targetRotation = Quaternion.FromToRotation(Vector3.up, hitInfo.normal);
            Quaternion finalRotation = Quaternion.RotateTowards(transform.rotation, targetRotation, float.PositiveInfinity);

            transform.rotation = finalRotation;
            
            float step = fallspeed * Time.deltaTime;
            transform.position = Vector3.MoveTowards(transform.position, hitInfo.point + hitInfo.normal * 0.5f, step);
        }
    }

    private bool GetRaycastDownAtNewPosition(Vector3 movementDirection, out RaycastHit hitInfo)
    {
        Vector3 newPosition = transform.position;
        Ray ray = new Ray(transform.position + movementDirection, transform.forward);

        if (Physics.Raycast(ray, out hitInfo, float.PositiveInfinity))
        {
            return true;
        }

        return false;
    }
}
