﻿using UnityEngine;

public class PlayerMovement : MonoBehaviour
{
    public GameObject planet;
    public Transform upperBody;
    public Transform lowerBody;

    public int health = 3;

    public GameObject bullet;
    public GameObject gun;
    public AudioSource audio;
    public GameObject sluck;
    public GameObject sluckHole;

    public GameObject box;

    private float fireStart = 0f;

    public GameObject fire;

    [System.Serializable]
    public struct Guns
    {
        public GameObject Gun;
        public GameObject Bullet;
        public bool pickedUp;
        public AudioClip GunSound;
        public float BulletSpeed;
        public float FireSpeed;
        public float BulletLifeTime;

        public int Damage;

        public float CoolDownTime;

        public float CameraShake;
    }

    public Guns[] guns;


    void Start()
    {
        audio = GetComponent<AudioSource>();
    }

    private void Update()
    {
        MoveCharacter();

        // Get the Screen positions of the object
        Vector2 positionOnScreen = Camera.main.WorldToViewportPoint(transform.position);

        // Get the Screen position of the mouse
        Vector2 mouseOnScreen = (Vector2)Camera.main.ScreenToViewportPoint(Input.mousePosition);

        // Get the angle between the points
        float angle = AngleBetweenTwoPoints(positionOnScreen, mouseOnScreen);
        
        // Ta Daaa
        upperBody.transform.rotation = Quaternion.Euler(new Vector3(0f, -angle, 0f));

        fire.GetComponent<ParticleSystem>().Simulate(0);

        RaycastHit hit;
        Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);
        if (Physics.Raycast(ray, out hit))
            box.transform.position = hit.point;

        // Shoot
        if (Input.GetMouseButton(0))
        {

            if (Time.time > fireStart + guns[StaticData.ChoosenGun].FireSpeed)
            {
                GameObject instance = Instantiate(guns[StaticData.ChoosenGun].Bullet, gun.transform.position, gun.transform.rotation) as GameObject;
                instance.transform.LookAt(box.transform);

                fire.GetComponent<ParticleSystem>().Simulate(1);
                audio.PlayOneShot(guns[StaticData.ChoosenGun].GunSound, 0.7F);
                GameObject _sluck = sluck;
                Instantiate(_sluck, sluckHole.transform.position, Random.rotation);
                iTween.ShakePosition(Camera.main.gameObject, new Vector3(guns[StaticData.ChoosenGun].CameraShake, guns[StaticData.ChoosenGun].CameraShake, guns[StaticData.ChoosenGun].CameraShake), 0.1f);

                //Debug.Log("DIT IS WAPEN " + StaticData.ChoosenGun);

                fireStart = Time.time;
            }       
        }
        

       
        if (Input.GetKeyDown(KeyCode.Alpha1))
        {
            StaticData.ChoosenGun = 0;
        }
        if (Input.GetKeyDown(KeyCode.Alpha2))
        {           
            if (guns[1].pickedUp == true)
            {
                Debug.Log("switch naar 2");
                StaticData.ChoosenGun = 1;
            }          
        }
        if (Input.GetKeyDown(KeyCode.Alpha3))
        {
            StaticData.ChoosenGun = 2;
        }
        if (Input.GetKeyDown(KeyCode.Alpha4))
        {
            StaticData.ChoosenGun = 3;
        }

        // Delete all enemies
        if (Input.GetKeyDown(KeyCode.K))
        {
            GameObject[] findEnemies = GameObject.FindGameObjectsWithTag("Enemy");

            foreach (GameObject item in findEnemies)
            {
                Destroy(item.gameObject);
            }
        }

    }

    float AngleBetweenTwoPoints(Vector3 a, Vector3 b)
    {
        return Mathf.Atan2(a.y - b.y, a.x - b.x) * Mathf.Rad2Deg;
    }

    private void MoveCharacter()
    {
        float accelx = 0;
        float accely = 0;
        float accelz = 0;

        if (Input.GetAxisRaw("Vertical") > 0)
        {
            accelx = -StaticData.Speed;
        }
        else if (Input.GetAxisRaw("Vertical") < 0)
        {
            accelx = StaticData.Speed;
        }

        if (Input.GetAxisRaw("Horizontal") > 0)
        {
            accelz = StaticData.Speed;
        }
        else if (Input.GetAxisRaw("Horizontal") < 0)
        {
            accelz = -StaticData.Speed;
        }

        planet.transform.Rotate(accelx, accely, accelz, Space.World);
    }
}
