﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Pods : MonoBehaviour
{
    GameObject planet;
    public GameObject[] SpawnLocations;
    public GameObject enemy;

    private bool landed = false;
    private bool spawned = false;

    public GameObject landingParticle;
    public GameObject landingFire;

    private void Start()
    {
        planet = GameObject.FindWithTag("planet");
    }
	
	// Update is called once per frame
	void Update ()
    {
        RaycastHit hit;
        Ray ray = new Ray(transform.position, transform.forward);
        if (!landed)
        {
            if (Physics.Raycast(ray, out hit, 1))
            {
                if (hit.transform.tag == "planet")
                    landed = true;

                landingParticle.SetActive(true);
                landingFire.SetActive(false);
            }
        }

        if (landed && !spawned)
        {
            for (int i = 0; i < SpawnLocations.Length; i++)
            {
                GameObject instance = Instantiate(enemy, SpawnLocations[i].transform.position, Quaternion.identity) as GameObject;
                instance.transform.parent = planet.transform;
            }
            spawned = true;
        }
    }
}
