﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WaveSystem : MonoBehaviour
{
    private int currentWave = 0;
    private GameObject planet;

    [System.Serializable]
    public struct Waves
    {
        public GameObject[] itemDrops;
        public GameObject[] pods;
    }

    public Waves[] waves;

	// Use this for initialization
	void Start ()
    {
        planet = GameObject.FindWithTag("planet");	
	}
	
	// Update is called once per frame
	void Update ()
    {
		if (StaticData.waveCleared && currentWave < waves.Length)
        {
            StaticData.waveCleared = false;

            for (int i = 0; i < waves[currentWave].pods.Length; i++)
            {
                Quaternion randomer = new Quaternion(Random.Range(0, 360), Random.Range(0, 360), Random.Range(0, 360), Random.Range(0, 360));
                GameObject instance = Instantiate(waves[currentWave].pods[i], planet.transform.position, randomer) as GameObject;
                
                instance.transform.position = instance.transform.forward * Random.Range(40,80);
                instance.transform.parent = planet.transform;
            }

            currentWave++;
        }

        int enemyAmount = GameObject.FindGameObjectsWithTag("Enemy").Length;

        int podAmount = GameObject.FindGameObjectsWithTag("POD").Length;

        if (enemyAmount == 0 && podAmount == 0)
            StaticData.waveCleared = true;
    }
}
